diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-mac.cc ns-3.42/src/wifi/model/wifi-mac.cc
--- ns-3.41/src/wifi/model/wifi-mac.cc	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-mac.cc	2024-05-29 15:29:47.212073800 -0700
@@ -36,9 +36,14 @@
 #include "ns3/log.h"
 #include "ns3/packet.h"
 #include "ns3/pointer.h"
+#include "ns3/shuffle.h"
+#include "ns3/string.h"
 #include "ns3/vht-configuration.h"
 
 #include <algorithm>
+#include <cmath>
+#include <iterator>
+#include <sstream>
 
 namespace ns3
 {
@@ -97,28 +102,38 @@
                 MakeBooleanChecker())
             .AddAttribute("Txop",
                           "The Txop object.",
+                          TypeId::ATTR_GET |
+                              TypeId::ATTR_CONSTRUCT, // prevent setting after construction
                           PointerValue(),
-                          MakePointerAccessor(&WifiMac::GetTxop),
+                          MakePointerAccessor(&WifiMac::GetTxop, &WifiMac::SetTxop),
                           MakePointerChecker<Txop>())
             .AddAttribute("VO_Txop",
                           "Queue that manages packets belonging to AC_VO access class.",
+                          TypeId::ATTR_GET |
+                              TypeId::ATTR_CONSTRUCT, // prevent setting after construction
                           PointerValue(),
-                          MakePointerAccessor(&WifiMac::GetVOQueue),
+                          MakePointerAccessor(&WifiMac::GetVOQueue, &WifiMac::SetVoQueue),
                           MakePointerChecker<QosTxop>())
             .AddAttribute("VI_Txop",
                           "Queue that manages packets belonging to AC_VI access class.",
+                          TypeId::ATTR_GET |
+                              TypeId::ATTR_CONSTRUCT, // prevent setting after construction
                           PointerValue(),
-                          MakePointerAccessor(&WifiMac::GetVIQueue),
+                          MakePointerAccessor(&WifiMac::GetVIQueue, &WifiMac::SetViQueue),
                           MakePointerChecker<QosTxop>())
             .AddAttribute("BE_Txop",
                           "Queue that manages packets belonging to AC_BE access class.",
+                          TypeId::ATTR_GET |
+                              TypeId::ATTR_CONSTRUCT, // prevent setting after construction
                           PointerValue(),
-                          MakePointerAccessor(&WifiMac::GetBEQueue),
+                          MakePointerAccessor(&WifiMac::GetBEQueue, &WifiMac::SetBeQueue),
                           MakePointerChecker<QosTxop>())
             .AddAttribute("BK_Txop",
                           "Queue that manages packets belonging to AC_BK access class.",
+                          TypeId::ATTR_GET |
+                              TypeId::ATTR_CONSTRUCT, // prevent setting after construction
                           PointerValue(),
-                          MakePointerAccessor(&WifiMac::GetBKQueue),
+                          MakePointerAccessor(&WifiMac::GetBKQueue, &WifiMac::SetBkQueue),
                           MakePointerChecker<QosTxop>())
             .AddAttribute(
                 "MpduBufferSize",
@@ -345,6 +360,35 @@
     return tid;
 }
 
+int64_t
+WifiMac::AssignStreams(int64_t stream)
+{
+    NS_LOG_FUNCTION(this << stream);
+    if (GetNLinks() > 1)
+    {
+        m_shuffleLinkIdsGen.GetRv()->SetStream(stream);
+        return 1;
+    }
+    return 0;
+}
+
+void
+WifiMac::NotifyConstructionCompleted()
+{
+    NS_LOG_FUNCTION(this);
+
+    if (!m_qosSupported)
+    {
+        SetupDcfQueue();
+        return;
+    }
+
+    for (const auto& [aci, ac] : wifiAcList)
+    {
+        SetupEdcaQueue(aci);
+    }
+}
+
 void
 WifiMac::DoInitialize()
 {
@@ -428,7 +472,7 @@
 WifiMac::SetDevice(const Ptr<WifiNetDevice> device)
 {
     m_device = device;
-    if (GetHtSupported())
+    if (device->GetHtConfiguration())
     {
         // the configured BlockAck buffer size can now be capped
         m_mpduBufferSize = std::min(m_mpduBufferSize, GetMaxBaBufferSize());
@@ -489,12 +533,62 @@
     }
 }
 
+void
+WifiMac::SetTxop(Ptr<Txop> dcf)
+{
+    NS_LOG_FUNCTION(this << dcf);
+    if (!m_qosSupported)
+    {
+        m_txop = dcf;
+    }
+}
+
 Ptr<Txop>
 WifiMac::GetTxop() const
 {
     return m_txop;
 }
 
+void
+WifiMac::SetVoQueue(Ptr<QosTxop> edca)
+{
+    NS_LOG_FUNCTION(this << edca);
+    if (m_qosSupported)
+    {
+        m_edca.emplace(AC_VO, edca);
+    }
+}
+
+void
+WifiMac::SetViQueue(Ptr<QosTxop> edca)
+{
+    NS_LOG_FUNCTION(this << edca);
+    if (m_qosSupported)
+    {
+        m_edca.emplace(AC_VI, edca);
+    }
+}
+
+void
+WifiMac::SetBeQueue(Ptr<QosTxop> edca)
+{
+    NS_LOG_FUNCTION(this << edca);
+    if (m_qosSupported)
+    {
+        m_edca.emplace(AC_BE, edca);
+    }
+}
+
+void
+WifiMac::SetBkQueue(Ptr<QosTxop> edca)
+{
+    NS_LOG_FUNCTION(this << edca);
+    if (m_qosSupported)
+    {
+        m_edca.emplace(AC_BK, edca);
+    }
+}
+
 Ptr<QosTxop>
 WifiMac::GetQosTxop(AcIndex ac) const
 {
@@ -622,24 +716,31 @@
 }
 
 void
+WifiMac::SetupDcfQueue()
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT(m_txop);
+
+    m_txop->SetTxMiddle(m_txMiddle);
+    m_txop->SetDroppedMpduCallback(
+        MakeCallback(&DroppedMpduTracedCallback::operator(), &m_droppedMpduCallback));
+}
+
+void
 WifiMac::SetupEdcaQueue(AcIndex ac)
 {
     NS_LOG_FUNCTION(this << ac);
 
-    // Our caller shouldn't be attempting to setup a queue that is
-    // already configured.
-    NS_ASSERT(m_edca.find(ac) == m_edca.end());
-
-    Ptr<QosTxop> edca = CreateObject<QosTxop>(ac);
-    edca->SetTxMiddle(m_txMiddle);
-    edca->GetBaManager()->SetTxOkCallback(
+    auto edcaIt = m_edca.find(ac);
+    NS_ASSERT(edcaIt != m_edca.cend());
+
+    edcaIt->second->SetTxMiddle(m_txMiddle);
+    edcaIt->second->GetBaManager()->SetTxOkCallback(
         MakeCallback(&MpduTracedCallback::operator(), &m_ackedMpduCallback));
-    edca->GetBaManager()->SetTxFailedCallback(
+    edcaIt->second->GetBaManager()->SetTxFailedCallback(
         MakeCallback(&MpduTracedCallback::operator(), &m_nackedMpduCallback));
-    edca->SetDroppedMpduCallback(
+    edcaIt->second->SetDroppedMpduCallback(
         MakeCallback(&DroppedMpduTracedCallback::operator(), &m_droppedMpduCallback));
-
-    m_edca.insert(std::make_pair(ac, edca));
 }
 
 void
@@ -725,31 +826,48 @@
         break;
     }
 
-    std::vector<uint32_t> cwValues(m_links.size());
-    std::vector<uint8_t> aifsnValues(m_links.size());
-    std::vector<Time> txopLimitValues(m_links.size());
-
-    std::fill(cwValues.begin(), cwValues.end(), cwMinValue);
-    dcf->SetMinCws(cwValues);
-    std::fill(cwValues.begin(), cwValues.end(), cwMaxValue);
-    dcf->SetMaxCws(cwValues);
-    std::fill(aifsnValues.begin(), aifsnValues.end(), aifsnValue);
-    dcf->SetAifsns(aifsnValues);
-    std::transform(isDsss.begin(),
-                   isDsss.end(),
-                   txopLimitValues.begin(),
-                   [&txopLimitDsss, &txopLimitNoDsss](bool dsss) {
-                       return (dsss ? txopLimitDsss : txopLimitNoDsss);
-                   });
-    dcf->SetTxopLimits(txopLimitValues);
+    const auto& userDefinedParams = dcf->GetUserAccessParams();
+
+    dcf->SetMinCws(!userDefinedParams.cwMins.empty()
+                       ? userDefinedParams.cwMins
+                       : std::vector<uint32_t>(m_links.size(), cwMinValue));
+    dcf->SetMaxCws(!userDefinedParams.cwMaxs.empty()
+                       ? userDefinedParams.cwMaxs
+                       : std::vector<uint32_t>(m_links.size(), cwMaxValue));
+    dcf->SetAifsns(!userDefinedParams.aifsns.empty()
+                       ? userDefinedParams.aifsns
+                       : std::vector<uint8_t>(m_links.size(), aifsnValue));
+
+    if (!userDefinedParams.txopLimits.empty())
+    {
+        dcf->SetTxopLimits(userDefinedParams.txopLimits);
+    }
+    else
+    {
+        std::vector<Time> txopLimitValues(m_links.size());
+        std::transform(isDsss.begin(),
+                       isDsss.end(),
+                       txopLimitValues.begin(),
+                       [&txopLimitDsss, &txopLimitNoDsss](bool dsss) {
+                           return (dsss ? txopLimitDsss : txopLimitNoDsss);
+                       });
+        dcf->SetTxopLimits(txopLimitValues);
+    }
 }
 
 void
-WifiMac::ConfigureStandard(WifiStandard standard)
-{
-    NS_LOG_FUNCTION(this << standard);
-    NS_ABORT_IF(standard >= WIFI_STANDARD_80211n && !m_qosSupported);
-    NS_ABORT_MSG_IF(m_links.empty(), "No PHY configured yet");
+WifiMac::CompleteConfig()
+{
+    NS_ASSERT_MSG(!m_links.empty(), "CompleteConfig cannot be called before creating links");
+
+    const auto& link = *m_links.cbegin()->second;
+
+    if (!link.phy || !link.stationManager || !link.channelAccessManager || !link.feManager)
+    {
+        return;
+    }
+
+    NS_LOG_FUNCTION(this);
 
     for (auto& [id, link] : m_links)
     {
@@ -758,23 +876,18 @@
             "[LinkID " << +id
                        << "] PHY must have been set and an operating channel must have been set");
 
-        // do not create a ChannelAccessManager and a FrameExchangeManager if they
-        // already exist (this function may be called after ResetWifiPhys)
-        if (!link->channelAccessManager)
-        {
-            link->channelAccessManager = CreateObject<ChannelAccessManager>();
-        }
+        NS_ABORT_MSG_IF(!link->channelAccessManager,
+                        "[LinkID " << +id << "] A channel access manager must have been set");
+
+        NS_ABORT_MSG_IF(!link->feManager,
+                        "[LinkID " << +id << "] A frame exchange manager must have been set");
+
         link->channelAccessManager->SetupPhyListener(link->phy);
+        link->channelAccessManager->SetupFrameExchangeManager(link->feManager);
 
-        if (!link->feManager)
-        {
-            link->feManager = SetupFrameExchangeManager(standard);
-        }
         link->feManager->SetWifiPhy(link->phy);
-        link->feManager->SetWifiMac(this);
-        link->feManager->SetLinkId(id);
-        link->channelAccessManager->SetLinkId(id);
-        link->channelAccessManager->SetupFrameExchangeManager(link->feManager);
+        link->feManager->SetMacTxMiddle(m_txMiddle);
+        link->feManager->SetMacRxMiddle(m_rxMiddle);
 
         if (m_txop)
         {
@@ -789,6 +902,8 @@
 
         ConfigurePhyDependentParameters(id);
     }
+
+    DoCompleteConfig();
 }
 
 void
@@ -809,55 +924,57 @@
     ConfigureContentionWindow(cwmin, cwmax);
 }
 
-Ptr<FrameExchangeManager>
-WifiMac::SetupFrameExchangeManager(WifiStandard standard)
+bool
+WifiMac::CreateLinksIfNeeded(std::size_t nLinks)
 {
-    NS_LOG_FUNCTION(this << standard);
-    NS_ABORT_MSG_IF(standard == WIFI_STANDARD_UNSPECIFIED, "Wifi standard not set");
-    Ptr<FrameExchangeManager> feManager;
-
-    if (standard >= WIFI_STANDARD_80211be)
-    {
-        feManager = CreateObject<EhtFrameExchangeManager>();
-    }
-    else if (standard >= WIFI_STANDARD_80211ax)
+    if (!m_links.empty())
     {
-        feManager = CreateObject<HeFrameExchangeManager>();
+        return false;
     }
-    else if (standard >= WIFI_STANDARD_80211ac)
-    {
-        feManager = CreateObject<VhtFrameExchangeManager>();
-    }
-    else if (standard >= WIFI_STANDARD_80211n)
+
+    for (std::size_t i = 0; i < nLinks; i++)
     {
-        feManager = CreateObject<HtFrameExchangeManager>();
+        m_links.emplace(i, CreateLinkEntity());
+        m_linkIds.insert(i);
     }
-    else if (m_qosSupported)
+    return true;
+}
+
+void
+WifiMac::SetFrameExchangeManagers(const std::vector<Ptr<FrameExchangeManager>>& feManagers)
+{
+    NS_LOG_FUNCTION(this);
+
+    if (!CreateLinksIfNeeded(feManagers.size()))
     {
-        feManager = CreateObject<QosFrameExchangeManager>();
+        NS_ABORT_MSG_IF(feManagers.size() != m_links.size(),
+                        "The number of provided Frame Exchange Manager objects ("
+                            << feManagers.size() << ") must match the number of existing links ("
+                            << m_links.size() << ")");
     }
-    else
+
+    for (auto managerIt = feManagers.cbegin(); auto& [id, link] : m_links)
     {
-        feManager = CreateObject<FrameExchangeManager>();
+        link->feManager = *managerIt++;
+        link->feManager->SetWifiMac(this);
+        link->feManager->SetLinkId(id);
+        // connect callbacks
+        link->feManager->GetWifiTxTimer().SetMpduResponseTimeoutCallback(
+            MakeCallback(&MpduResponseTimeoutTracedCallback::operator(),
+                         &m_mpduResponseTimeoutCallback));
+        link->feManager->GetWifiTxTimer().SetPsduResponseTimeoutCallback(
+            MakeCallback(&PsduResponseTimeoutTracedCallback::operator(),
+                         &m_psduResponseTimeoutCallback));
+        link->feManager->GetWifiTxTimer().SetPsduMapResponseTimeoutCallback(
+            MakeCallback(&PsduMapResponseTimeoutTracedCallback::operator(),
+                         &m_psduMapResponseTimeoutCallback));
+        link->feManager->SetDroppedMpduCallback(
+            MakeCallback(&DroppedMpduTracedCallback::operator(), &m_droppedMpduCallback));
+        link->feManager->SetAckedMpduCallback(
+            MakeCallback(&MpduTracedCallback::operator(), &m_ackedMpduCallback));
     }
 
-    feManager->SetMacTxMiddle(m_txMiddle);
-    feManager->SetMacRxMiddle(m_rxMiddle);
-    feManager->SetAddress(GetAddress());
-    feManager->GetWifiTxTimer().SetMpduResponseTimeoutCallback(
-        MakeCallback(&MpduResponseTimeoutTracedCallback::operator(),
-                     &m_mpduResponseTimeoutCallback));
-    feManager->GetWifiTxTimer().SetPsduResponseTimeoutCallback(
-        MakeCallback(&PsduResponseTimeoutTracedCallback::operator(),
-                     &m_psduResponseTimeoutCallback));
-    feManager->GetWifiTxTimer().SetPsduMapResponseTimeoutCallback(
-        MakeCallback(&PsduMapResponseTimeoutTracedCallback::operator(),
-                     &m_psduMapResponseTimeoutCallback));
-    feManager->SetDroppedMpduCallback(
-        MakeCallback(&DroppedMpduTracedCallback::operator(), &m_droppedMpduCallback));
-    feManager->SetAckedMpduCallback(
-        MakeCallback(&MpduTracedCallback::operator(), &m_ackedMpduCallback));
-    return feManager;
+    CompleteConfig();
 }
 
 Ptr<FrameExchangeManager>
@@ -866,6 +983,28 @@
     return GetLink(linkId).feManager;
 }
 
+void
+WifiMac::SetChannelAccessManagers(const std::vector<Ptr<ChannelAccessManager>>& caManagers)
+{
+    NS_LOG_FUNCTION(this);
+
+    if (!CreateLinksIfNeeded(caManagers.size()))
+    {
+        NS_ABORT_MSG_IF(caManagers.size() != m_links.size(),
+                        "The number of provided Channel Access Manager objects ("
+                            << caManagers.size() << ") must match the number of existing links ("
+                            << m_links.size() << ")");
+    }
+
+    for (auto managerIt = caManagers.cbegin(); auto& [id, link] : m_links)
+    {
+        link->channelAccessManager = *managerIt++;
+        link->channelAccessManager->SetLinkId(id);
+    }
+
+    CompleteConfig();
+}
+
 Ptr<ChannelAccessManager>
 WifiMac::GetChannelAccessManager(uint8_t linkId) const
 {
@@ -885,21 +1024,21 @@
 {
     NS_LOG_FUNCTION(this);
 
-    NS_ABORT_MSG_UNLESS(m_links.empty() || m_links.size() == stationManagers.size(),
-                        "If links have been already created, the number of provided "
-                        "Remote Manager objects ("
+    if (!CreateLinksIfNeeded(stationManagers.size()))
+    {
+        NS_ABORT_MSG_IF(stationManagers.size() != m_links.size(),
+                        "The number of provided Remote Manager objects ("
                             << stationManagers.size()
-                            << ") must "
-                               "match the number of links ("
-                            << m_links.size() << ")");
+                            << ") must match the number of existing links (" << m_links.size()
+                            << ")");
+    }
 
-    for (std::size_t i = 0; i < stationManagers.size(); i++)
+    for (auto managerIt = stationManagers.cbegin(); auto& [id, link] : m_links)
     {
-        // the link may already exist in case PHY objects were configured first
-        auto [it, inserted] = m_links.emplace(i, CreateLinkEntity());
-        m_linkIds.insert(i);
-        it->second->stationManager = stationManagers[i];
+        link->stationManager = *managerIt++;
     }
+
+    CompleteConfig();
 }
 
 Ptr<WifiRemoteStationManager>
@@ -1011,7 +1150,7 @@
         }
 
         std::unique_ptr<LinkEntity> linkToMove;
-        NS_ASSERT(m_links.find(from) != m_links.cend());
+        NS_ASSERT(m_links.contains(from));
         linkToMove.swap(m_links.at(from)); // from is now out of m_links
         auto empty = from;                 // track empty cell in m_links
 
@@ -1062,6 +1201,14 @@
     }
 }
 
+bool
+WifiMac::Is6GhzBand(uint8_t linkId) const
+{
+    auto phy = GetLink(linkId).phy;
+    NS_ASSERT(phy);
+    return phy->GetPhyBand() == WIFI_PHY_BAND_6GHZ;
+}
+
 void
 WifiMac::UpdateTidToLinkMapping(const Mac48Address& mldAddr,
                                 WifiDirection dir,
@@ -1148,23 +1295,20 @@
     NS_LOG_FUNCTION(this);
     ResetWifiPhys();
 
-    NS_ABORT_MSG_UNLESS(m_links.empty() || m_links.size() == phys.size(),
-                        "If links have been already created, the number of provided "
-                        "PHY objects ("
-                            << phys.size()
-                            << ") must match the number "
-                               "of links ("
+    if (!CreateLinksIfNeeded(phys.size()))
+    {
+        NS_ABORT_MSG_IF(phys.size() != m_links.size(),
+                        "The number of provided PHY objects ("
+                            << phys.size() << ") must match the number of existing links ("
                             << m_links.size() << ")");
+    }
 
-    for (std::size_t i = 0; i < phys.size(); i++)
+    for (auto phyIt = phys.cbegin(); auto& [id, link] : m_links)
     {
-        // the link may already exist in case we are setting new PHY objects
-        // (ResetWifiPhys just nullified the PHY(s) but left the links)
-        // or the remote station managers were configured first
-        auto [it, inserted] = m_links.emplace(i, CreateLinkEntity());
-        m_linkIds.insert(i);
-        it->second->phy = phys[i];
+        link->phy = *phyIt++;
     }
+
+    CompleteConfig();
 }
 
 Ptr<WifiPhy>
@@ -1197,25 +1341,6 @@
     NS_LOG_FUNCTION(this << enable);
     NS_ABORT_IF(IsInitialized());
     m_qosSupported = enable;
-
-    if (!m_qosSupported)
-    {
-        // create a non-QoS TXOP
-        m_txop = CreateObject<Txop>();
-        m_txop->SetTxMiddle(m_txMiddle);
-        m_txop->SetDroppedMpduCallback(
-            MakeCallback(&DroppedMpduTracedCallback::operator(), &m_droppedMpduCallback));
-    }
-    else
-    {
-        // Construct the EDCAFs. The ordering is important - highest
-        // priority (Table 9-1 UP-to-AC mapping; IEEE 802.11-2012) must be created
-        // first.
-        SetupEdcaQueue(AC_VO);
-        SetupEdcaQueue(AC_VI);
-        SetupEdcaQueue(AC_BE);
-        SetupEdcaQueue(AC_BK);
-    }
 }
 
 bool
@@ -1388,7 +1513,12 @@
                                const Mac48Address& address,
                                const std::set<uint8_t>& linkIds)
 {
-    NS_LOG_FUNCTION(this << reason << address);
+    std::stringstream ss;
+    if (g_log.IsEnabled(ns3::LOG_FUNCTION))
+    {
+        std::copy(linkIds.cbegin(), linkIds.cend(), std::ostream_iterator<uint16_t>(ss, " "));
+    }
+    NS_LOG_FUNCTION(this << reason << address << ss.str());
     NS_ASSERT(m_scheduler);
 
     for (const auto linkId : linkIds)
@@ -1429,10 +1559,22 @@
                                  const Mac48Address& address,
                                  const std::set<uint8_t>& linkIds)
 {
-    NS_LOG_FUNCTION(this << reason << address);
     NS_ASSERT(m_scheduler);
 
-    for (const auto linkId : linkIds)
+    // shuffle link IDs not to unblock links always in the same order
+    std::vector<uint8_t> shuffledLinkIds(linkIds.cbegin(), linkIds.cend());
+    Shuffle(shuffledLinkIds.begin(), shuffledLinkIds.end(), m_shuffleLinkIdsGen.GetRv());
+
+    std::stringstream ss;
+    if (g_log.IsEnabled(ns3::LOG_FUNCTION))
+    {
+        std::copy(shuffledLinkIds.cbegin(),
+                  shuffledLinkIds.cend(),
+                  std::ostream_iterator<uint16_t>(ss, " "));
+    }
+    NS_LOG_FUNCTION(this << reason << address << ss.str());
+
+    for (const auto linkId : shuffledLinkIds)
     {
         auto& link = GetLink(linkId);
         auto linkAddr = link.stationManager->GetAffiliatedStaAddress(address).value_or(address);
@@ -1758,16 +1900,18 @@
 }
 
 bool
-WifiMac::GetHtSupported() const
+WifiMac::GetHtSupported(uint8_t linkId) const
 {
-    return bool(GetDevice()->GetHtConfiguration());
+    return (GetDevice()->GetHtConfiguration() &&
+            GetWifiPhy(linkId)->GetPhyBand() != WIFI_PHY_BAND_6GHZ);
 }
 
 bool
 WifiMac::GetVhtSupported(uint8_t linkId) const
 {
     return (GetDevice()->GetVhtConfiguration() &&
-            GetWifiPhy(linkId)->GetPhyBand() != WIFI_PHY_BAND_2_4GHZ);
+            GetWifiPhy(linkId)->GetPhyBand() != WIFI_PHY_BAND_2_4GHZ &&
+            GetWifiPhy(linkId)->GetPhyBand() != WIFI_PHY_BAND_6GHZ);
 }
 
 bool
@@ -1845,7 +1989,7 @@
     {
         return 256;
     }
-    NS_ASSERT(address ? GetHtSupported(*address) : GetHtSupported());
+    NS_ASSERT(address ? GetHtSupported(*address) : static_cast<bool>(GetHtConfiguration()));
     return 64;
 }
 
@@ -1949,7 +2093,7 @@
 {
     NS_LOG_FUNCTION(this);
     ExtendedCapabilities capabilities;
-    capabilities.SetHtSupported(GetHtSupported());
+    capabilities.SetHtSupported(GetHtSupported(SINGLE_LINK_OP_ID));
     capabilities.SetVhtSupported(GetVhtSupported(SINGLE_LINK_OP_ID));
     // TODO: to be completed
     return capabilities;
@@ -1959,7 +2103,7 @@
 WifiMac::GetHtCapabilities(uint8_t linkId) const
 {
     NS_LOG_FUNCTION(this << +linkId);
-    NS_ASSERT(GetHtSupported());
+    NS_ASSERT(GetHtSupported(linkId));
     HtCapabilities capabilities;
 
     auto phy = GetWifiPhy(linkId);
@@ -2153,6 +2297,41 @@
 
     return capabilities;
 }
+
+He6GhzBandCapabilities
+WifiMac::GetHe6GhzBandCapabilities(uint8_t linkId) const
+{
+    auto phy = GetLink(linkId).phy;
+    NS_ASSERT_MSG(phy->GetPhyBand() == WIFI_PHY_BAND_6GHZ,
+                  "Getting HE 6 GHz band capabilities on band different than 6 GHz");
+
+    He6GhzBandCapabilities capabilities;
+
+    // Set Maximum MPDU Length subfield
+    const auto maxAmsduSize =
+        std::max({m_voMaxAmsduSize, m_viMaxAmsduSize, m_beMaxAmsduSize, m_bkMaxAmsduSize});
+    if (maxAmsduSize <= 3839)
+    {
+        capabilities.SetMaxMpduLength(3895);
+    }
+    else if (maxAmsduSize <= 7935)
+    {
+        capabilities.SetMaxMpduLength(7991);
+    }
+    else
+    {
+        capabilities.SetMaxMpduLength(11454);
+    }
+
+    auto maxAmpduLength =
+        std::max({m_voMaxAmpduSize, m_viMaxAmpduSize, m_beMaxAmpduSize, m_bkMaxAmpduSize});
+    // round to the next power of two minus one
+    maxAmpduLength = (1UL << static_cast<uint32_t>(std::ceil(std::log2(maxAmpduLength + 1)))) - 1;
+    // The maximum A-MPDU length in HE 6 GHz Band Capabilities elements ranges from 2^13-1 to 2^20-1
+    capabilities.SetMaxAmpduLength(std::min(std::max(maxAmpduLength, 8191U), 1048575U));
+
+    return capabilities;
+}
 
 EhtCapabilities
 WifiMac::GetEhtCapabilities(uint8_t linkId) const
